<?php
# 09
# http://localhost/editor.php
# nutno spustit "C:\Program Files\Apache Group\Apache\bin\apache.exe"
# nutno provozovat ve Firefoxu, Internet Explorer neumi pruhledne PNG

error_reporting(0);
header('Content-Type: text/html; charset=utf-8');
require 'functions.php';

// vstupni formular
?>
	<form action="editor.php" method="post" enctype="multipart/form-data">
	  <label for="infile">Otevřít soubor:</label>
	  <input type="file" name="infile" id="infile" />
	  <input type="submit" value="Nahrát" />
	</form>
<?php

if (empty($_FILES['infile']) && empty($_POST['work_file']))
{
	exit;
}

if (empty($_FILES['infile']))
{
	$WORK_FILE = $_POST['work_file'];
}
else
{
	move_uploaded_file($_FILES['infile']['tmp_name'], 'work_file.xml');
	$WORK_FILE = 'work_file.xml';
}

?>

<form action="editor.php" method="post">
  <input type="hidden" name="work_file" value="<?php echo htmlspecialchars($WORK_FILE); ?>">
  Transpozice: <input name="trans" value="<?= htmlspecialchars($_REQUEST['trans']); ?>"><br >
  Takt: <select name="takt_change">
    <option value="3">3/4</option>
    <option value="4">4/4</option>
    <option value="5">5/4</option>
  </select>
  <input type="submit" value="Překreslit">
</form>

<?php

// nacist vstupni soubor
$skladba = nacti_vstup($WORK_FILE, $takt_skladby);

if (!empty($_REQUEST['takt_change'])) $takt_skladby = (int)$_REQUEST['takt_change'];


// nachystat blok pro notovou osnovu
$dir = 'noty/male/png_pruhledne/';
?>
<style>
#osnova {
	display: block;
	position: relative;
	background-image: url('osnova.gif');
	background-repeat: repeat-x;
	width: 200000px;
	height: 50px;
}
#osnova img {
	position: absolute;
}
</style>

<nobr id="osnova">
  <img src="<?= $dir; ?>klic.png" style="position: relative; top: 0px;">
  <img src="<?= "{$dir}takt_$takt_skladby.png"; ?>" style="position: relative; top: -11px;">
<?php

define('NOTE_WIDTH', 17);
// projit znaky (noty/pomlky) a vygenerovat takty
$takt = 0;	// pocet dob v aktualnim taktu
$x = 40;	// aktualni x-pozice na osnove
$i_skladba = 0;
$buffer = array($skladba[$i_skladba++]);	// buffer not
$lig_begin = 0; $lig_end = 0;	// pozice zacatku a konce ligatury
do
{
	// sebrat notu z bufferu
	$znak = array_shift($buffer);
	
	if (!empty($_REQUEST['trans']))
	{
		$znak['vyska'] += $_REQUEST['trans'];
		if ($znak['vyska'] < 0 || $znak['vyska'] >23) exit('chyba rozsahu');
	}
	
	$takt_zbyva = $takt_skladby;
	// pripadne rozsekat, pokud ma nestandardni delku
	while (!in_array($znak['delka'], array(0.5, 1, 2, 4)) || $znak['delka'] > $takt_zbyva)
	{
		// zaciname novou ligaturu - pouze pro noty
		if ($znak['typ'] == 'nota' && !$lig_begin)
		{
			$lig_begin = $x;
		}
		
		$takt_zbyva -= $takt;
		
		$novy = $znak;
		
		// na jakou delku zkratime
		if ($znak['delka'] > 4)
			$zkr = min(4, $takt_zbyva);
		elseif ($znak['delka'] > 2)
			$zkr = min(2, $takt_zbyva);
		elseif ($znak['delka'] > 1)
			$zkr = min(1, $takt_zbyva);
		else
			$zkr = min(0.5, $takt_zbyva);
		
		$novy['delka'] = $znak['delka'] - $zkr;
		$znak['delka'] = $zkr;
		
		$buffer[] = $novy;
	}
	
	// pokud neni zadny zbytek, nacist dalsi znak
	if (empty($buffer) && isset($skladba[$i_skladba]))
	{
		$buffer[] = $skladba[$i_skladba++];
		if ($lig_begin) $lig_end = $x;
	}
	
	// ligatura
	if ($lig_begin && $lig_end)
	{
		// nakreslit ligaturu
		printf('<img src="ligatura.php?width=%d" style="left: %dpx; top: 0;"> ',
			$lig_end - $lig_begin,
			$lig_begin + 5
			);
		
		$lig_begin = 0; $lig_end = 0;
	}
	
	printf('<img src="%s" style="top: %dpx; left: %dpx;">',
		$dir . obrazek_znaku($znak),
		obrazek_umisteni($znak),
		$x
		);
	echo "\n";
	$takt += $znak['delka'];
	$x += NOTE_WIDTH;
	
	// konec taktu?
	if ($takt >= $takt_skladby)
	{
		printf('<img src="cara.gif" style="left: %dpx;">', $x);
		echo "\n";
		$takt = 0;
		$x += 10;
	}
} while (!empty($buffer));
?>
</nobr>
